#include <sys/types.h>
#include "config.h"

#include "defs.h"
#include "xmodule.h"
#include "service.h"
#include "sconf.h"
#include "msg.h"
#include "main.h"

status_e xinetd_sm_register(struct service *sp, struct module_conf *mc, connection_s *cp, void **arg)
{
	char *instances = pset_pointer(mc->config, 0);

	if( debug.on )
		msg(LOG_DEBUG, "per_source.so", "xinetd_sm_register entered");

	if( EQ(instances, "UNLIMITED") )
		(int)mc->priv = UNLIMITED;
	else {
		if ( parse_base10(instances, (int *)&mc->priv) || (int)mc->priv < 0 ) 
		return FAILED;
	}
	return OK;
}

status_e xinetd_sm_connect(struct service *sp, struct module_conf *mc, connection_s *cp, void **arg)
{
   int n;
   int u;
	if( debug.on )
		msg(LOG_DEBUG, "per_source.so", "xinetd_sm_connect entered");
   if( (int)mc->priv != UNLIMITED ) {
      if ( conn_xaddress(cp) != NULL ) {
         n = 0 ; 
         for ( u = 0 ; u < pset_count( SERVERS( ps ) ) ; u++ ) {
            struct server *serp = NULL;
            connection_s *cop = NULL;
            serp = SERP( pset_pointer( SERVERS( ps ), u ) ) ;
            if ( (SERVER_SERVICE( serp ) == sp) &&
               ( cop = SERVER_CONNECTION( serp ) ) ) {
   
               if ( SC_IPV6( sp->svc_conf ) && IN6_ARE_ADDR_EQUAL( &(cop->co_remote_address.sa_in6.sin6_addr), &((conn_xaddress(cp))->sa_in6.sin6_addr)) )
                  n++;
               if ( SC_IPV4( sp->svc_conf ) && (cop->co_remote_address.sa_in.sin_addr.s_addr == (conn_xaddress(cp))->sa_in.sin_addr.s_addr) )
                  n++;
            }
         }

         if ( n >= (int)mc->priv )
            return( FAILED ) ;
      }
   }

	return OK;
}

status_e xinetd_sm_unregister(struct service *sp, struct module_conf *mc, connection_s *cp, void **arg)
{
	if( debug.on )
		msg(LOG_DEBUG, "per_source.so", "xinetd_sm_unregister entered");
	return OK;
}
